import java.io.*;
import java.net.*;
import net.fsp.*;

public class fspfactory extends downloadfactory
{
	private FSPsession ses;
	public static int delay=FSPsession.DEFAULT_DELAY;
	public static int maxdelay=60000;

	/* public constructor */
	fspfactory(String URL,qfile qf,boolean dirc) throws java.net.MalformedURLException
	{
		super(URL,qf,dirc);
	}

	/* this procedure should modify protected variables as result */
	protected void processRequest(InetAddress server,int port,boolean nocache) throws IOException,java.net.MalformedURLException
	{
		/* connect to server */
		ses=new FSPsession(server,port);
		/* set delays and timeouts */
		ses.setTimeout(dmachine.timeout);
		ses.setDelay(delay);
		ses.setMaxDelay(maxdelay);

		/* stat file */
		FSPstat stat;
		stat=FSPutil.stat(ses,url.getFile());
		if(stat==null)
		{
			/* file doesn't exists */
			this.rc=downloadcore.DOWNLOAD_FATAL;
			return;
		}

		fileSize=stat.length;
		lastModified=stat.lastmod;

		if(havebytes>0)
		{
			this.rc=downloadcore.DOWNLOAD_RESUME;
		} else
		{
			this.rc=downloadcore.DOWNLOAD_OK;
		}
		contentSize=fileSize-havebytes;
		if(contentSize<0) contentSize=0;
		datain=new DataInputStream(
				new FSPInputStream(ses,url.getFile())
		);
		datain.skip(havebytes);
	}

	protected synchronized void close()
	{
		super.close(); // close data connection
		ses.close(); // close FSP session
	}

} /* class */
